'*******************************************************************************
'Programm for Display ST7735R 1.8Zoll 128x160
'         and Display ILI9163 1.8Zoll 128x160
'Bascom IDE 2.0.7.7
'
'Version:13012014
'By Hkipnik
'  Copyright by H.Kipnik 2012
'Date 13.01.2014
'*******************************************************************************

$nocompile
'*******************************************************************************
'  Draw Pic_rom x start -- y start -- Breite -- Hhe
'  Bin Bild vom Flach speicher
'  umgewandelt mit dem Programm Image2LCD
'  bevor die Sub aufgerufen wird
'  mu erst mit Restore der Label pointer gesetzt werden.
'*******************************************************************************
Sub Lcd_pic_rom(byval Xs As Byte , Byval Ys As Byte , Byval Breite As Byte , Byval Height As Byte)
  Local Zael As Word , Xb As Byte , Yb As Byte
  Local Lang As Word
  Local R1 As Byte , R2 As Byte
  Lang = Breite * Height
  Xb = Breite + Xs                                          'X end
  Decr Xb
  Yb = Ys + Height
  Call Lcd_set_window(xs , Ys , Xb , Yb)

  Lcd_cs = 0
  Lcd_dc = 1

  For Zael = 1 To Lang                                      ' bis Y end Position
     Read R1
     Read R2
     Spiout R1 , 1
     Spiout R2 , 1
  Next Zael

  Lcd_cs = 1
#if Modus = 1
  Call Lcd_set_window(0 , 0 , 159 , 127)
#else
  Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
'*******************************************************************************
'  Draw Pic x start -- y start -- Breite -- Hhe
'  von der SD Card in Bin Daten 2 Byte per Pixel
'  umgewandelt mit dem Programm Image2LCD
'*******************************************************************************
#if Sdcard = 1
Sub Lcd_pic(byval Xs As Byte , Byval Ys As Byte , Byval Breite As Byte , Byval Height As Byte , Byval Bnama As String)
  Local Zael As Byte , Xb As Byte , Yb As Byte
  Local Line_len As Word                                    ', Llen As Word
  Local Rest As Word , Lines As Word , Rest1 As Byte
  Rest1 = 0

  Line_len = Height * Breite
  Line_len = Line_len * 2

  Lines = Line_len / 250
  Rest = Line_len Mod 250
  Rest1 = Rest

  Xb = Breite + Xs                                          'X end
  Decr Xb
  Yb = Ys + Height

  Call Lcd_set_window(xs , Ys , Xb , Yb)

  Lcd_cs = 1
  Lcd_dc = 1

  Reset Mmc_cs
  Open Bnama For Binary As #10

  For Zael = 1 To Lines                                     ' bis Y end Position
       Mmc_cs = 0
      Get #10 , Rgb_data(1) , , 250                         ' 250 byteDaten einlesen
       Mmc_cs = 1
       Lcd_cs = 0
       Spiout Rgb_data(1) , 250                             '250 byte raus
       Lcd_cs = 1
  Next Zael

     If Rest1 > 1 Then
        Mmc_cs = 0
      Get #10 , Rgb_data(1) , , Rest1                       'Rest einlesen
       Mmc_cs = 1
       Lcd_cs = 0
       Spiout Rgb_data(1) , Rest1                           'und raus
       Lcd_cs = 1
     End If
  Close #10

#if Modus = 1
  Call Lcd_set_window(0 , 0 , 159 , 127)
#else
  Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
#endif
'*******************************************************************************
' Draw Box x start -- y start -- width -- height -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
Sub Lcd_box(byval Xstart As Byte , Byval Ystart As Byte , Byval X_length As Byte , Byval Y_height As Byte , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)
   Local Xend As Byte , Yend As Byte
   Local Pixel As Word , Zahl As Word
   Xend = Xstart + X_length
   Yend = Ystart + Y_height
 If Fill = 1 Then
   Call Lcd_set_window(xstart , Ystart , Xend , Yend)
   Incr X_length
   Incr Y_height
   Pixel = X_length * Y_height
   Rgb_16 = Color

   Lcd_cs = 0
   Lcd_dc = 1
   For Zahl = 1 To Pixel
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
   Next
 Elseif Fill = 2 Then
   Call Lcd_set_window(xstart , Ystart , Xend , Yend)
   Incr X_length
   Incr Y_height
   Pixel = X_length * Y_height
   Rgb_16 = Color

   Lcd_cs = 0
   Lcd_dc = 1
   For Zahl = 1 To Pixel
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
   Next

   Call Lcd_line(xstart , Ystart , Xend , Ystart , 1 , Bordercolor)
   Call Lcd_line(xstart , Yend , Xend , Yend , 1 , Bordercolor)
   Call Lcd_line(xstart , Ystart , Xstart , Yend , 1 , Bordercolor)
   Call Lcd_line(xend , Ystart , Xend , Yend , 1 , Bordercolor)
 Elseif Fill = 3 Then
   Call Lcd_line(xstart , Ystart , Xend , Ystart , 1 , Color)
   Call Lcd_line(xstart , Yend , Xend , Yend , 1 , Color)
   Call Lcd_line(xstart , Ystart , Xstart , Yend , 1 , Color)
   Call Lcd_line(xend , Ystart , Xend , Yend , 1 , Color)
 End If
#if Modus = 1
 Call Lcd_set_window(0 , 0 , 159 , 127)
#else
 Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
'*******************************************************************************
'draw Circle fill
'*******************************************************************************
Sub Lcd_fill_circle(byval X As Byte , Byval Y As Byte , Byval Radius As Byte , Byval Color1 As Word)
   Local Xy_radius As Integer , Zahly As Integer , Zahlx As Integer , Y1 As Integer , X1 As Integer
   Local Y11 As Integer , X11 As Integer , Xy As Integer , X2 As Byte , Y2 As Byte
    Xy_radius = Radius * Radius
    Y1 = -radius
    X1 = -radius

   For Zahly = Y1 To Radius
       Y11 = Zahly * Zahly
    For Zahlx = X1 To Radius
       X11 = Zahlx * Zahlx
       Xy = X11 + Y11
       If Xy <= Xy_radius Then
       X2 = X + Zahlx
       Y2 = Y + Zahly
       Call Lcd_set_pixel(x2 , Y2 , Color1)
       End If
    Next
   Next
#if Modus = 1
 Call Lcd_set_window(0 , 0 , 159 , 127)
#else
 Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
'*******************************************************************************
' draw Circle
'*******************************************************************************
Sub Lcd_circle(byval X As Byte , Byval Y As Byte , Byval Radius As Byte , Byval Color As Word)
  Local X0 As Byte , Y0 As Byte , Error As Integer
  Local Xp As Byte , Yp As Byte , Xe As Byte , Ye As Byte

  Error = -radius
  Xp = Radius
  Yp = 0

  While Xp >= Yp
    X0 = X + Xp : Y0 = Y + Yp
    Call Lcd_set_pixel(x0 , Y0 , Color)                     'no fill
    X0 = X - Xp : Y0 = Y + Yp
    Call Lcd_set_pixel(x0 , Y0 , Color)
    X0 = X + Xp : Y0 = Y - Yp
    Call Lcd_set_pixel(x0 , Y0 , Color)
    X0 = X - Xp : Y0 = Y - Yp
    Call Lcd_set_pixel(x0 , Y0 , Color)

    X0 = X + Yp : Y0 = Y + Xp
    Call Lcd_set_pixel(x0 , Y0 , Color)
    X0 = X - Yp : Y0 = Y + Xp
    Call Lcd_set_pixel(x0 , Y0 , Color)
    X0 = X + Yp : Y0 = Y - Xp
    Call Lcd_set_pixel(x0 , Y0 , Color)
    X0 = X - Yp : Y0 = Y - Xp
    Call Lcd_set_pixel(x0 , Y0 , Color)

    Error = Error + Yp
    Incr Yp
    Error = Error + Yp

    If Error >= 0 Then
      Decr Xp
      Error = Error - Xp
      Error = Error - Xp
    End If

  Wend
#if Modus = 1
 Call Lcd_set_window(0 , 0 , 159 , 127)
#else
 Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
'*******************************************************************************
' Draw line X - Y Start to X - Y End - Pen Width - Color
'*******************************************************************************
Sub Lcd_line(byval X1 As Byte , Byval Y1 As Byte , Byval X2 As Byte , Byval Y2 As Byte , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte
   Local Xpoint As Byte , Ypoint As Byte
   Local Y_count As Byte , X_count As Byte
   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         Xpoint = X_pos
         Ypoint = Y
         Call Lcd_set_pixel(xpoint , Ypoint , Color)
         X_count = Xpoint
         For Pen_count = 2 To Pen_width
             Incr X_count
             Call Lcd_set_pixel(x_count , Ypoint , Color)
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
          Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         Xpoint = X
         Ypoint = Y_pos
         Call Lcd_set_pixel(xpoint , Ypoint , Color)
         Y_count = Ypoint
         For Pen_count = 2 To Pen_width
              Incr Y_count
            Call Lcd_set_pixel(xpoint , Y_count , Color)
         Next Pen_count
         Incr Pos
      Next X
   End If
#if Modus = 1
    Call Lcd_set_window(0 , 0 , 159 , 127)
#else
    Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
End Sub
'*******************************************************************************
'LCD_Text  String -- X -- Y Start -- Font -- Forecolor -- Backcolor
'*******************************************************************************
Sub Lcd_text(byval S As String , Xoffset As Byte , Yoffset As Byte , Fontset As Byte , Forecolor As Word , Backcolor As Word )
    Local Tempstring As String * 1 , Temp As Word           'Dim local the variables
    Local A As Byte , Pixels As Byte , Count As Byte , Carcount As Byte , Lus As Byte
    Local Row As Byte , Block As Byte , Byteseach As Byte , Blocksize As Byte , Dummy As Byte
    Local Colums As Byte , Columcount As Byte , Rowcount As Byte , Stringsize As Byte
    Local Xpos As Byte , Ypos As Byte , Pixel As Word , Pixelcount As Byte
    Local Offset As Word

    Rgb_16 = Forecolor

   Stringsize = Len(s) - 1                                  'Size of the text string -1 because we must start with 0
    Select Case Fontset
      Case 1 :
         Block = Lookup(0 , Font8x8)                        'Add or remove here fontset's that you need or not,
         Byteseach = Lookup(1 , Font8x8)
         Blocksize = Lookup(2 , Font8x8)
         Dummy = Lookup(3 , Font8x8)
      Case 2 :
         Block = Lookup(0 , Font12x16)
         Byteseach = Lookup(1 , Font12x16)
         Blocksize = Lookup(2 , Font12x16)
         Dummy = Lookup(3 , Font12x16)

      Case 3 :
         Block = Lookup(0 , Font8x12)
         Byteseach = Lookup(1 , Font8x12)
         Blocksize = Lookup(2 , Font8x12)
         Dummy = Lookup(3 , Font8x12)
      Case 4 :
         Block = Lookup(0 , Font6x10)
         Byteseach = Lookup(1 , Font6x10)
         Blocksize = Lookup(2 , Font6x10)
         Dummy = Lookup(3 , Font6x10)
       Case 5 :
         Block = Lookup(0 , Font10x16)
         Byteseach = Lookup(1 , Font10x16)
         Blocksize = Lookup(2 , Font10x16)
         Dummy = Lookup(3 , Font10x16)
   End Select
   Colums = Blocksize / Block                               'Calculate the numbers of colums
   Row = Block * 8                                          'Row is always 8 pixels high = 1 byte, so working with row in steps of 8.
   Row = Row - 1                                            'Want to start with row=0 instead of 1
   Colums = Colums - 1                                      'Same for the colums
   For Carcount = 0 To Stringsize                           'Loop for the numbers of caracters that must be displayed
      Temp = Carcount + 1                                   'Cut the text string in seperate caracters
      Tempstring = Mid(s , Temp , 1)
      Offset = Asc(tempstring) - 32                         'Font files start with caracter 32
      Offset = Offset * Blocksize
      Offset = Offset + 4
      Temp = Carcount * Byteseach
      Temp = Temp + Xoffset
      For Rowcount = 0 To Row Step 8                        'Loop for numbers of rows
          A = Rowcount + Yoffset
          Xpos = Temp
          For Columcount = 0 To Colums                      'Loop for numbers of Colums
             Select Case Fontset
                Case 1 : Pixels = Lookup(offset , Font8x8)
                Case 2 : Pixels = Lookup(offset , Font12x16)
                Case 3 : Pixels = Lookup(offset , Font8x12)
                Case 4 : Pixels = Lookup(offset , Font6x10 )
                Case 5 : Pixels = Lookup(offset , Font10x16 )
             End Select
             Ypos = A
              For Pixelcount = 0 To 7                       'Loop for 8 pixels to be set or not
                  Pixel = Pixels.0                          'Set the pixel (or not)
                  If Pixel = 1 Then
                     Call Lcd_set_pixel(xpos , Ypos , Forecolor)
                  Else
                     If Backcolor <> Transparent Then
                      Call Lcd_set_pixel(xpos , Ypos , Backcolor)
                     End If
                  End If
                  Shift Pixels , Right                      'Shift the byte 1 bit to the right so the next pixel comes availible
                  Incr Ypos                                 'Each pixel on his own spot
              Next Pixelcount
             Incr Offset
             Incr Xpos                                      'Do some calculation to get the caracter on the correct Xposition
          Next Columcount
      Next Rowcount
   Next Carcount
End Sub


'*******************************************************************************
'Set Pixel
'*******************************************************************************
Sub Lcd_set_pixel(byval X As Byte , Byval Y As Byte , Byval Color As Word)

    Temp = &H2A
    Lcd_cs = 0
    Lcd_dc = 0
    Spiout Temp , 1
    Temp = &H00
    Lcd_dc = 1
    Spiout Temp , 1
    Spiout X , 1
    Spiout Temp , 1                                         '00
    Spiout X , 1
    Temp = &H2B
    Lcd_dc = 0
    Spiout Temp , 1
    Temp = &H00
    Lcd_dc = 1
    Spiout Temp , 1
    Spiout Y , 1
    Spiout Temp , 1                                         '00
    Spiout Y , 1
    Temp = &H2C
    Lcd_dc = 0
    Spiout Temp , 1
    Rgb_16 = Color
    Lcd_dc = 1
    Spiout Rgb16_high , 1
    Spiout Rgb16_low , 1
    Lcd_cs = 1
End Sub
'*******************************************************************************
'  Clear Display
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)
   Local Zahl As Byte , Zahl1 As Byte

   Rgb_16 = Color

#if Modus = 1
  Call Lcd_set_window(0 , 0 , 159 , 127)
#else
  Call Lcd_set_window(0 , 0 , 127 , 159)
#endif
  Lcd_cs = 0
  Lcd_dc = 1
  For Zahl = 1 To 160                                       '20480
    For Zahl1 = 1 To 32                                     '128
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
      Spiout Rgb16_high , 1
      Spiout Rgb16_low , 1
    Next
   Next
  Lcd_cs = 1
End Sub
'*******************************************************************************
'  Set Window Area to write Data
'*******************************************************************************
Sub Lcd_set_window(byval Xs As Byte , Byval Ys As Byte , Byval Xe As Byte , Byval Ye As Byte)

    Temp = &H2A
    Lcd_cs = 0
    Lcd_dc = 0
    Spiout Temp , 1
    Temp = &H00
    Lcd_dc = 1
    Spiout Temp , 1
    Spiout Xs , 1
    Spiout Temp , 1
    Spiout Xe , 1

    Temp = &H2B
    Lcd_cs = 0
    Lcd_dc = 0
    Spiout Temp , 1
    Temp = &H00
    Lcd_dc = 1
    Spiout Temp , 1
    Spiout Ys , 1
    Spiout Temp , 1
    Spiout Ye , 1

    Temp = &H2C
    Lcd_dc = 0
    Spiout Temp , 1
    Lcd_cs = 1

End Sub
'*******************************************************************************
' send Color Data
'*******************************************************************************
Sub Lcd_write_color(byval Color As Word)
  Rgb_16 = Color

  Lcd_cs = 0
  Lcd_dc = 1
  Spiout Rgb16_high , 1
  Spiout Rgb16_low , 1
  Lcd_cs = 1
End Sub
'*******************************************************************************
' send Command
'*******************************************************************************
Sub Lcd_write_command(byval Command As Byte)
 Lcd_cs = 0
 Lcd_dc = 0
 Spiout Command , 1
 Lcd_cs = 1
End Sub
'*******************************************************************************
'  send Data
'*******************************************************************************
Sub Lcd_write_data(byval Da_ta As Byte)
 Lcd_cs = 0
 Lcd_dc = 1
 Spiout Da_ta , 1
 Lcd_cs = 1
End Sub
'*******************************************************************************
' Init the display   ST7735 or ILI6163
'*******************************************************************************
Sub Lcd_init()                                              'INIT ST7735

 Lcd_reset = 0
 Waitms 150
 Lcd_reset = 1
 Waitms 150


#if Driver = 0
 Call Lcd_write_command(&H01)                               'Softreset
 Waitms 150
 Call Lcd_write_command(&H11)                               'sleep Mode off
 Waitms 500

 Call Lcd_write_command(&Hb1)                               'frame control normal
 Call Lcd_write_data(&H01)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H2d)

 Call Lcd_write_command(&Hb2)                               'frame control idle
 Call Lcd_write_data(&H01)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H2d)

 Call Lcd_write_command(&Hb3)                               'frame control partial
 Call Lcd_write_data(&H01)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H2d)
 Call Lcd_write_data(&H01)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H2d)

 Call Lcd_write_command(&Hb4)                               'display inversion
 Call Lcd_write_data(&B0000_0111)                           '07

 Call Lcd_write_command(&Hc0)                               'power control
 Call Lcd_write_data(&H2a)                                  '2a
 Call Lcd_write_data(&H02)
 Call Lcd_write_data(&H84)

 Call Lcd_write_command(&Hc1)                               'power control2
 Call Lcd_write_data(&Hc5)

 Call Lcd_write_command(&Hc2)                               'power control3
 Call Lcd_write_data(&H0a)
 Call Lcd_write_data(&H00)

 Call Lcd_write_command(&Hc3)                               'power control4
 Call Lcd_write_data(&H8a)
 Call Lcd_write_data(&H2a)

 Call Lcd_write_command(&Hc4)                               'power control5
 Call Lcd_write_data(&H8a)
 Call Lcd_write_data(&Hee)

 Call Lcd_write_command(&Hc5)                               'power control
 Call Lcd_write_data(&H0e)

 Call Lcd_write_command(&H20)                               'no invert display

#if Modus = 1                                               'Landscape
 #if Disp_typ = 0
   Call Lcd_write_command(&H36)                             'memory access control
   Call Lcd_write_data(&Ha0)                                'R-G-B  Black tab
 #else
 Call Lcd_write_command(&H36)                               'memory access control
 Call Lcd_write_data(&Ha8)                                  'B-G-R  Red Tab
 #endif
#endif
#if Modus = 0                                               'Portrait
 #if Disp_typ = 0
   Call Lcd_write_command(&H36)                             'memory access control
   Call Lcd_write_data(&Hc0)                                'R-G-B  Black tab
 #else
 Call Lcd_write_command(&H36)                               'memory access control
 Call Lcd_write_data(&Hc8)                                  'B-G-R  Red Tab
 #endif
#endif

 Call Lcd_write_command(&H3a)                               'color mode 16Bit
 Call Lcd_write_data(&H05)

 Call Lcd_write_command(&H2a)                               'column set
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H7f)                                  '127 end     7f

 Call Lcd_write_command(&H2b)                               'row set
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H9f)                                  '159 end   9f
'(
 Call Lcd_write_command(&He0)
 Call Lcd_write_data(&H02)
 Call Lcd_write_data(&H1c)
 Call Lcd_write_data(&H07)
 Call Lcd_write_data(&H12)
 Call Lcd_write_data(&H37)
 Call Lcd_write_data(&H32)
 Call Lcd_write_data(&H29)
 Call Lcd_write_data(&H2d)
 Call Lcd_write_data(&H29)
 Call Lcd_write_data(&H25)
 Call Lcd_write_data(&H2b)
 Call Lcd_write_data(&H39)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H01)
 Call Lcd_write_data(&H03)
 Call Lcd_write_data(&H10)

 Call Lcd_write_command(&He1)
 Call Lcd_write_data(&H03)
 Call Lcd_write_data(&H1d)
 Call Lcd_write_data(&H07)
 Call Lcd_write_data(&H06)
 Call Lcd_write_data(&H2e)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H29)
 Call Lcd_write_data(&H2d)
 Call Lcd_write_data(&H2e)
 Call Lcd_write_data(&H2e)
 Call Lcd_write_data(&H37)
 Call Lcd_write_data(&H3f)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H02)
 Call Lcd_write_data(&H10)
')
Call Lcd_write_command(&He0)
 Call Lcd_write_data(&H0f)
 Call Lcd_write_data(&H1a)
 Call Lcd_write_data(&H0f)
 Call Lcd_write_data(&H18)
 Call Lcd_write_data(&H2f)
 Call Lcd_write_data(&H28)
 Call Lcd_write_data(&H20)
 Call Lcd_write_data(&H22)
 Call Lcd_write_data(&H1f)
 Call Lcd_write_data(&H1b)
 Call Lcd_write_data(&H23)
 Call Lcd_write_data(&H37)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H07)
 Call Lcd_write_data(&H02)
 Call Lcd_write_data(&H10)

 Call Lcd_write_command(&He1)
 Call Lcd_write_data(&H0f)
 Call Lcd_write_data(&H1b)
 Call Lcd_write_data(&H0f)
 Call Lcd_write_data(&H17)
 Call Lcd_write_data(&H33)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&H29)
 Call Lcd_write_data(&H2e)
 Call Lcd_write_data(&H30)
 Call Lcd_write_data(&H30)
 Call Lcd_write_data(&H39)
 Call Lcd_write_data(&H3f)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H07)
 Call Lcd_write_data(&H03)
 Call Lcd_write_data(&H10)
 Call Lcd_write_command(&H29)
 Waitms 100
 Call Lcd_write_command(&H13)                               'normal display on
 Waitms 100


#endif


'*******************************************************************************
#if Driver = 1                                              'INIT ILI9163

 Call Lcd_write_command(&H01)                               'Softreset
 Waitms 150
 Call Lcd_write_command(&H11)                               'sleep Mode off
 Waitms 300

 Call Lcd_write_command(&H26)
 Call Lcd_write_data(&H04)

 Call Lcd_write_command(&Hb1)
 Call Lcd_write_data(&H0b)
 Call Lcd_write_data(&H14)

 Call Lcd_write_command(&Hc0)
 Call Lcd_write_data(&H08)
 Call Lcd_write_data(&H00)

 Call Lcd_write_command(&Hc1)
 Call Lcd_write_data(&H05)

 Call Lcd_write_command(&Hc5)
 Call Lcd_write_data(&H41)
 Call Lcd_write_data(&H30)

 Call Lcd_write_command(&Hc7)
 Call Lcd_write_data(&Hc1)

 Call Lcd_write_command(&Hec)
 Call Lcd_write_data(&H1b)

 Call Lcd_write_command(&H3a)
 Call Lcd_write_data(&H55)
 Waitms 100
 Call Lcd_write_command(&H2a)                               'column set
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H7f)                                  '127 end     7f

 Call Lcd_write_command(&H2b)                               'row set
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H00)
 Call Lcd_write_data(&H9f)                                  '159 end   9f

#if Modus = 1                                               'Landscape

 Call Lcd_write_command(&H36)                               'memory access control
 Call Lcd_write_data(&Ha8)                                  'B-G-R  Red Tab

#endif
#if Modus = 0                                               'Portrait

 Call Lcd_write_command(&H36)                               'memory access control
 Call Lcd_write_data(&Hc8)                                  'B-G-R  Red Tab

#endif

 Call Lcd_write_command(&Hb7)
 Call Lcd_write_data(&H00)

 Call Lcd_write_command(&Hf2)
 Call Lcd_write_data(&H00)

 Call Lcd_write_command(&He0)
 Call Lcd_write_data(&H28)
 Call Lcd_write_data(&H24)
 Call Lcd_write_data(&H22)
 Call Lcd_write_data(&H31)
 Call Lcd_write_data(&H2b)
 Call Lcd_write_data(&H0e)
 Call Lcd_write_data(&H53)
 Call Lcd_write_data(&Ha5)
 Call Lcd_write_data(&H42)
 Call Lcd_write_data(&H16)
 Call Lcd_write_data(&H18)
 Call Lcd_write_data(&H12)
 Call Lcd_write_data(&H1a)
 Call Lcd_write_data(&H14)
 Call Lcd_write_data(&H03)

 Call Lcd_write_command(&He1)
 Call Lcd_write_data(&H17)
 Call Lcd_write_data(&H1b)
 Call Lcd_write_data(&H1d)
 Call Lcd_write_data(&H0e)
 Call Lcd_write_data(&H14)
 Call Lcd_write_data(&H11)
 Call Lcd_write_data(&H2c)
 Call Lcd_write_data(&Ha5)
 Call Lcd_write_data(&H3d)
 Call Lcd_write_data(&H09)
 Call Lcd_write_data(&H27)
 Call Lcd_write_data(&H2d)
 Call Lcd_write_data(&H25)
 Call Lcd_write_data(&H2b)
 Call Lcd_write_data(&H3c)


 Call Lcd_write_command(&H29)
 Waitms 100
 Call Lcd_write_command(&H13)                               'normal display on
 Waitms 100
#endif

End Sub